package server

import "time"

const (
	// DefaultConcurrency is the maximum number of concurrent connections
	// the Server may serve by default (i.e. if Server.Concurrency isn't set).
	DefaultConcurrency = 256 * 1024

	DefaultKeepAlive = 0

	// DefaultHandshakeTimeout is default value of websocket handshake Timeout
	DefaultHandshakeTimeout = 0

	// DefaultReadBufferSize is default value of Read Buffer Size
	DefaultReadBufferSize = 0
	// DefaultWriteBufferSize is default value of Write Buffer Size
	DefaultWriteBufferSize = 0
	// DefaultReadTimeout is default value of read timeout
	DefaultReadTimeout = 0
	// DefaultWriteTimeout is default value of write timeout
	DefaultWriteTimeout = 0
	// DefaultEnableCompression is default value of support compression
	DefaultEnableCompression = false
	// DefaultMaxMessageSize is default size for a message read from the peer
	DefaultMaxMessageSize = 4096
	// DefaultPongTimeout is default value of websocket pong Timeout
	DefaultPongTimeout = 60 * time.Second
	// DefaultPingTimeout is default value of websocket ping Timeout
	DefaultPingTimeout = 10 * time.Second
	// DefaultPingPeriod is default value of send ping period
	DefaultPingPeriod = (DefaultPingTimeout * 9) / 10

	DefaultReconnectInterval = 5 * time.Second
	DefaultReconnectTryTime  = 10

	DefaultCompressionThreshold = 1024
)
